#include "opencv2/opencv.hpp"

#include <iostream>
#include <vector>
#include <string>
#include <fstream>

using namespace cv;
using namespace std;

void filter_rects(const std::vector<cv::Rect>& candidates, std::vector<cv::Rect>& objects);

int main()
{
    
    HOGDescriptor hog;    
    //carrega o perfil já treinado para pessoas
    hog.setSVMDetector(HOGDescriptor::getDefaultPeopleDetector());
    
    Mat image = imread("zex2.png");
    
    vector<Rect> bb, bb_filtered; //bounding box dos resultados

    // detector opencv padrão para pessoas
    hog.detectMultiScale(image, bb, 0, cv::Size(8,8), cv::Size(32,32), 1.05, 2);

    //filtra para tirar bounding box iguais
    filter_rects(bb, bb_filtered);

    //desenha caixas
    for (int ff = 0; ff < bb_filtered.size(); ++ff){
        cv::Rect r = bb_filtered[ff];
        cv::rectangle(image, r.tl(), r.br(), Scalar(0,255,0), 2);

    }

    imshow("detector", image);
    waitKey(0);
    return 0;
}

void filter_rects(const vector<Rect>& candidates, vector<Rect>& objects)
{
    int i, j;
    for (i = 0; i < candidates.size(); ++i)
    {
        cv::Rect r = candidates[i];

        for (j = 0; j < candidates.size(); ++j)
            if (j != i && (r & candidates[j]) == r)
                break;

        if (j == candidates.size())
            objects.push_back(r);
    }
}